﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
		
	Private Gradient1, Gradient2 As BitmapCreator
	Private Brush1, Brush2 As BCBrush
	Public bc1, bc2 As BitmapCreator
	
	
	'For Analog and Digital Square
	Private LastColorRoundedBorder1, LastColorRoundedBorder2  As Int
	Private LastWidthRoundedBorder, LastHeightRoundedBorder As Int
	Private LastRoundedThickBorder As Boolean
	Private LastRoundedInnerBevel As Boolean
	Private LastColorRoundedBackground1, LastColorRoundedBackground2 As Int
	Private LastRadiusRounded As Int
	
	'For Digital Circle
	Private LastColorCircleBorder1, LastColorCircleBorder2 As Int
	Private LastWidthCircleBorder, LastHeightCircleBorder As Int
	Private LastCircleThickBorder As Boolean
	Private LastCircleInnerBevel As Boolean
	Private LastColorCircleBackground1, LastColorCircleBackground2 As Int

End Sub

'Draw Analog Gauge With Background and Border
Sub DrawRoundedAnalogBackgroundandBorder(Width As Int, Height As Int, Radius As Int, Radius2 As Int, Radius3 As Int, Clrs() As Int, clrs2() As Int, InnerBevel As Boolean, ThickBorder As Boolean, BorderWidth As Int)
	If LastColorRoundedBorder1 = Clrs(0) And LastColorRoundedBorder2 = Clrs(1) And LastColorRoundedBackground1 = clrs2(0) And LastColorRoundedBackground2 = clrs2(1) And LastWidthRoundedBorder = Width And LastHeightRoundedBorder = Height And LastRoundedThickBorder = ThickBorder And LastRoundedInnerBevel = InnerBevel And LastRadiusRounded = Radius Then
		Log("Reusing DrawRoundedAnalogBackgroundandBorder")
	Else
			
		'Outter Border
		Gradient1.Initialize(10, Height)
		Gradient1.FillGradient(Clrs, Gradient1.TargetRect, "TOP_BOTTOM")
		Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
		bc1.Initialize(Width, Height)	'First Square
		bc1.DrawRectRounded2(bc1.TargetRect, Brush1, True, 5, Radius)
		
		'Inner Border
		If InnerBevel = True Then
			Gradient1.Initialize(10, Height)
			Gradient1.FillGradient(Clrs, Gradient1.TargetRect, "BOTTOM_TOP")
			Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
			Dim rectGauge10 As B4XRect
			rectGauge10.Initialize(BorderWidth, BorderWidth, Width - BorderWidth, Height - BorderWidth)
			bc1.DrawRectRounded2(rectGauge10, Brush1, True, 5, Radius2)
		End If
		
		'Background
		Gradient1.Initialize(Width, Height)
		Gradient1.FillRadialGradient(clrs2, Gradient1.TargetRect)
		Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
		Dim RectGauge11 As B4XRect
		RectGauge11.Initialize(BorderWidth * 2, BorderWidth * 2, Width - BorderWidth * 2, Height - BorderWidth * 2)
		bc1.DrawRectRounded2(RectGauge11, Brush1, True, 5, Radius3)
	
		LastColorRoundedBorder1 = Clrs(0)
		LastColorRoundedBorder2 = Clrs(1)
		LastColorRoundedBackground1 = clrs2(0)
		LastColorRoundedBackground2 = clrs2(1)
		LastWidthRoundedBorder = Width
		LastHeightRoundedBorder = Height
		LastRoundedThickBorder = ThickBorder
		LastRoundedInnerBevel = InnerBevel
		LastRadiusRounded = Radius
	End If

End Sub

'Draw Digital Square with Background and Border (Uses same Container from Analog Gauge
Sub DrawRoundedDigitalSquareBackgroundandBorder(Width As Int, Height As Int, Radius As Int, Radius2 As Int, Radius3 As Int, Clrs() As Int, clrs2() As Int, InnerBevel As Boolean, ThickBorder As Boolean, BorderWidth As Int)
	If LastColorRoundedBorder1 = Clrs(0) And LastColorRoundedBorder2 = Clrs(1) And LastColorRoundedBackground1 = clrs2(0) And LastColorRoundedBackground2 = clrs2(1) And LastWidthRoundedBorder = Width And LastHeightRoundedBorder = Height And LastRoundedThickBorder = ThickBorder And LastRoundedInnerBevel = InnerBevel And LastRadiusRounded = Radius Then
		Log("Reusing DrawRoundedDigitalSquareBackgroundandBorder")
	Else
		
		If ThickBorder = False Then
			'Outter Border
			Gradient1.Initialize(10, Height)
			Gradient1.FillGradient(Clrs, Gradient1.TargetRect, "TOP_BOTTOM")
			Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
			bc1.Initialize(Width, Height)	'First Square
			bc1.DrawRectRounded2(bc1.TargetRect, Brush1, True, 5, Radius)
			
			'Inner Border
			If InnerBevel = True Then
				Gradient1.Initialize(10, Height)
				Gradient1.FillGradient(Clrs, Gradient1.TargetRect, "BOTTOM_TOP")
				Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
				Dim rectGauge10 As B4XRect
				rectGauge10.Initialize(BorderWidth, BorderWidth, Width - BorderWidth, Height - BorderWidth)
				bc1.DrawRectRounded2(rectGauge10, Brush1, True, 5, Radius2)
			End If
			
			'Background
			Gradient1.Initialize(Width, Height)
			Gradient1.FillRadialGradient(clrs2, Gradient1.TargetRect)
			Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
			Dim RectGauge11 As B4XRect
			RectGauge11.Initialize(BorderWidth * 2, BorderWidth * 2, Width - BorderWidth * 2, Height - BorderWidth * 2)
			bc1.DrawRectRounded2(RectGauge11, Brush1, True, 5, Radius3)
		Else
			
			'Outter Border
			Gradient1.Initialize(10, Height)
			Gradient1.FillGradient(Clrs, Gradient1.TargetRect, "TOP_BOTTOM")
			Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
			bc1.Initialize(Width, Height)	'First Square
			bc1.DrawRectRounded2(bc1.TargetRect, Brush1, True, 5, Radius)
			
			'Inner Border
			If InnerBevel = True Then
				Gradient1.Initialize(10, Height)
				Gradient1.FillGradient(Clrs, Gradient1.TargetRect, "BOTTOM_TOP")
				Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
				Dim rectGauge10 As B4XRect
				rectGauge10.Initialize(BorderWidth + (BorderWidth/2), BorderWidth + (BorderWidth/2), Width - (BorderWidth + BorderWidth/2), Height - (BorderWidth + BorderWidth/2))
				bc1.DrawRectRounded2(rectGauge10, Brush1, True, 5, Radius2)
			End If
			
			'Background
			Gradient1.Initialize(Width, Height)
			Gradient1.FillRadialGradient(clrs2, Gradient1.TargetRect)
			Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
			Dim RectGauge11 As B4XRect
			RectGauge11.Initialize(BorderWidth * 2.25, BorderWidth * 2.25, Width - (BorderWidth * 2.25), Height - (BorderWidth * 2.25))
			bc1.DrawRectRounded2(RectGauge11, Brush1, True, 5, Radius3)
		End If
		
		LastColorRoundedBorder1 = Clrs(0)
		LastColorRoundedBorder2 = Clrs(1)
		LastColorRoundedBackground1 = clrs2(0)
		LastColorRoundedBackground2 = clrs2(1)
		LastWidthRoundedBorder = Width
		LastHeightRoundedBorder = Height
		LastRoundedThickBorder = ThickBorder
		LastRoundedInnerBevel = InnerBevel
		LastRadiusRounded = Radius
	End If

End Sub

'Draw Digital Circle with Background and Border
Sub DrawRoundedDigitalCircleBackgroundandBorder(Width As Int, Height As Int, Clrs() As Int, clrs2() As Int, InnerBevel As Boolean, ThickBorder As Boolean, BorderWidth As Int)
	If LastColorCircleBorder1 = Clrs(0) And LastColorCircleBorder2 = Clrs(1) And LastColorCircleBackground1 = clrs2(0) And LastColorCircleBackground2 = clrs2(1) And LastWidthCircleBorder = Width And LastHeightCircleBorder = Height And LastCircleThickBorder = ThickBorder And LastCircleInnerBevel = InnerBevel Then
		Log("Reusing DrawRoundedDigitalCircleBackgroundandBorder")
	Else
		
		If ThickBorder = False Then
			'Outter Border
			Gradient2.Initialize(10, Height)
			Gradient2.FillGradient(Clrs, Gradient2.TargetRect, "TOP_BOTTOM")
			Brush2 = Gradient2.CreateBrushFromBitmapCreator(Gradient2)
			bc2.Initialize(Width, Height)
			Dim xWidth As Float = Floor(Width/2)
			Dim xHeight As Float = Floor(Height/2)
			bc2.DrawCircle2(xWidth, xHeight, xWidth, Brush2, True, 5)
					
			'Inner Border
			If InnerBevel = True Then
				Gradient2.Initialize(10, Height)
				Gradient2.FillGradient(Clrs, Gradient2.TargetRect, "BOTTOM_TOP")
				Brush2 = Gradient2.CreateBrushFromBitmapCreator(Gradient2)
				Dim xWidth As Float = Floor(Width/2)
				Dim xHeight As Float = Floor(Height/2)
				Dim RadiusDraw As Int = xWidth - BorderWidth
				RadiusDraw = Round(RadiusDraw)
				bc2.DrawCircle2(xWidth, xHeight, RadiusDraw, Brush2, True, 5)
			End If
			
			'Background
			Gradient2.Initialize(Width, Height)
			Gradient2.FillRadialGradient(clrs2, Gradient2.TargetRect)
			Brush2 = Gradient2.CreateBrushFromBitmapCreator(Gradient2)
			Dim xWidth As Float = Floor(Width/2)
			Dim xHeight As Float = Floor(Height/2)
			Dim RadiusDraw As Int = xWidth - (BorderWidth * 2)
			RadiusDraw = Round(RadiusDraw)
			bc2.DrawCircle2(xWidth, xHeight, RadiusDraw, Brush2, True, 5)
		Else
			'Outter Border
			Gradient2.Initialize(10, Height)
			Gradient2.FillGradient(Clrs, Gradient2.TargetRect, "TOP_BOTTOM")
			Brush2 = Gradient2.CreateBrushFromBitmapCreator(Gradient2)
			bc2.Initialize(Width, Height)
			Dim xWidth As Float = Floor(Width/2)
			Dim xHeight As Float = Floor(Height/2)
			bc2.DrawCircle2(xWidth, xHeight, xWidth, Brush2, True, 5)

			'Inner Border
			If InnerBevel = True Then
				Gradient2.Initialize(10, Height)
				Gradient2.FillGradient(Clrs, Gradient2.TargetRect, "BOTTOM_TOP")
				Brush2 = Gradient2.CreateBrushFromBitmapCreator(Gradient2)
				Dim xWidth As Float = Floor(Width/2)
				Dim xHeight As Float = Floor(Height/2)
				Dim RadiusDraw As Int = xWidth - (BorderWidth + (BorderWidth/2))
				RadiusDraw = Round(RadiusDraw)
				bc2.DrawCircle2(xWidth, xHeight, RadiusDraw, Brush2, True, 5)
			End If
		
			'Background
			Gradient2.Initialize(Width, Height)
			Gradient2.FillRadialGradient(clrs2, Gradient2.TargetRect)
			Brush2 = Gradient2.CreateBrushFromBitmapCreator(Gradient2)
			Dim xWidth As Float = Floor(Width/2)
			Dim xHeight As Float = Floor(Height/2)
			Dim RadiusDraw As Int = xWidth - (BorderWidth * 2.25)
			RadiusDraw = Round(RadiusDraw)
			bc2.DrawCircle2(xWidth, xHeight, RadiusDraw, Brush2, True, 5)
'		
		End If
		
		LastColorCircleBorder1 = Clrs(0)
		LastColorCircleBorder2 = Clrs(1)
		LastColorCircleBackground1 = clrs2(0)
		LastColorCircleBackground2 = clrs2(1)
		LastWidthCircleBorder = Width
		LastHeightCircleBorder = Height
		LastCircleThickBorder = ThickBorder
		LastCircleInnerBevel = InnerBevel
	End If

End Sub



